config/routes.rb
Gfw::Application.routes.draw do

  mount JasmineRails::Engine => '/specs' if defined?(JasmineRails)

  #legacy
    # stories
    # get '/stories' => redirect("/stayinformed/crowdsourced-stories")

    # 2004-2009 era
    get '/english' => redirect('/')
    get '/french' => redirect('/')
    get '/bahasa' => redirect('/')
    get '/english/index.htm' => redirect('/')
    get '/french/index.htm' => redirect('/')
    get '/bahasa/index.htm' => redirect('/')
    get '/english/about(/:section)' => redirect('/about')
    get '/french/about(/:section)' => redirect('/about')
    get '/bahasa/about(/:section)' => redirect('/about')
    get '/english/pdfs(/:section)' => redirect("sources")
    get '/french/pdfs(/:section)' => redirect("sources")
    get '/bahasa/pdfs(/:section)' => redirect("sources")
    get '/english(/:id)(/:id2)(/:id3)' => redirect('/countries')
    get '/french(/:id)(/:id2)(/:id3)' => redirect('/countries')
    get '/bahasa(/:id)(/:id2)(/:id3)' => redirect('/countries')
    get '/common(/:section)' => redirect("sources")
    get '/common(/:section)(/:section)' => redirect("sources")
    get '/common(/:section)(/:section)(/:section)' => redirect("sources")
    get '/assets(/:content)' => redirect('/')

    # howto
    get '/howto/video' => redirect("/howto")
    get '/howto/general_questions' => redirect("/howto/faqs")
    get '/howto/terminology' => redirect("/howto/faqs")
    get '/howto/data' => redirect("/howto/faqs")
    get '/howto/web_platform' => redirect("/howto/faqs")
    get '/howto/for_business' => redirect("/howto/faqs")

    # about
    get '/about/video' => redirect("/about")
    get '/about/gfw' => redirect("/about/about-gfw")
    get '/about/partners' => redirect("/about/the-gfw-partnership")
    get '/partners' => redirect("/about/the-gfw-partnership")
    get '/about/users' => redirect("/about")
    get '/about/small_grants_fund' => redirect("/getinvolved/apply-to-the-small-grants-fund")
    get '/about/testers' => redirect("/about")

  resources :stories

  # terms
  post '/accept' => 'home#accept_and_redirect'

  # static
  get '/data' => redirect("sources")
  get '/sources' => 'static#data'
  get '/sources(/:section)' => 'static#data'
  get '/my_gfw' => 'connect#index'
  get '/my_gfw-login' => 'connect#login'

  # get '/stayinformed' => redirect('stayinformed/crowdsourced-stories')
  get '/stayinformed' => 'static#keep'
  get '/stayinformed(/:section)' => 'static#keep'
  get '/stayinformed-stories' => 'static#keepstories'

  get '/getinvolved' => 'static#getinvolved'
  get '/getinvolved(/:section)' => 'static#getinvolved'
  get '/feedback' => 'static#feedback'

  # howto
  get '/howto' => 'static#howto'
  get '/howto(/:section)' => 'static#howto'

  # about
  get '/about' => 'static#about'
  get '/about(/:section)' => 'static#about'

  # explore
  get '/explore' => 'static#explore'
  get '/explore(/:section)' => 'static#explore'


  get '/notsupportedbrowser' => 'static#old', :as => 'notsupportedbrowser'
  get '/terms' => 'static#terms'
  get '/accept_terms' => 'static#accept_terms'

  # map
  get '/map' => 'map#index'
  get '/map/*path' => 'map#index'
  get '/map/:zoom/:lat/:lng/:iso/:maptype(/:baselayers)' => 'map#index', :lat => /[^\/]+/, :lng => /[^\/]+/
  get '/map/:zoom/:lat/:lng/:iso/:maptype(/:baselayers/:sublayers)' => 'map#index', :lat => /[^\/]+/, :lng => /[^\/]+/
  get '/map/:zoom/:lat/:lng/:iso(/:basemap/:baselayer)' => 'map#index', :lat => /[^\/]+/, :lng => /[^\/]+/

  get '/embed/map' => 'map#embed'
  get '/embed/map/*path' => 'map#embed'
  get '/embed/map/:zoom/:lat/:lng/:iso/:maptype(/:baselayers)' => 'map#embed', :lat => /[^\/]+/, :lng => /[^\/]+/
  get '/embed/map/:zoom/:lat/:lng/:iso/:maptype(/:baselayers/:sublayers)' => 'map#embed', :lat => /[^\/]+/, :lng => /[^\/]+/
  get '/embed/map/:zoom/:lat/:lng/:iso(/:basemap/:baselayer)' => 'map#embed', :lat => /[^\/]+/, :lng => /[^\/]+/
  get '/embed/map/:zoom/:lat/:lng/:iso/:basemap/:baselayer(/:filters)' => 'map#embed', :lat => /[^\/]+/, :lng => /[^\/]+/

  # countries
  get '/countries' => 'countries#index'
  get '/country/:id' => 'countries#show', :as => 'country'

  get '/country_info/:id/:box',to: redirect('/country/%{id}#%{box}')
  # todo => validate id
  get '/country/:id/:area_id' => 'countries#show', :as => 'country_area'

  get '/countries/overview' => 'countries#overview'

  # search
  get '/search(/:query)(/:page)' => 'search#index'

  # download links
  post '/download' => 'download#create_download'

  # media
  post 'media/upload' => 'media#upload'
  get 'media/show' => 'media#show'

  # embed
  get '/embed/country/:id' => 'embed#countries_show'
  get '/embed/country_info/:id/:box' => 'embed#countries_show_info', :as => 'embed_country_box'
  get '/embed/country/:id/:area_id' => 'embed#countries_show'
  get '/embed/countries/overview' => 'embed#countries_overview'

  get '/landing' => 'landing#index'


  # robots
  get '/robots', to: redirect('/robots.txt'), format: false
  get '/robots.:format' => 'robots#index'

  root 'landing#index'




end

app/controllers/home_controller.rb
class HomeController < ApplicationController

  skip_before_filter :check_terms, :only => [:accept_and_redirect]
  before_filter :load_circles, :only => [:index]

  def index
    @circles = load_circles
    @title = I18n.translate 'home.index.title'
    @desc = 'Global Forest Watch (GFW) is a dynamic online forest monitoring and alert system that empowers people everywhere to better manage forests.'
  end

  def accept_and_redirect
    cookies.permanent[ENV['TERMS_COOKIE'].to_sym] = { :value => true, :domain => ENV['GFW_HOST'] }

    redirect_to session[:return_to].nil? ? root_path : session[:return_to]
  end

  private

    def load_circles
      begin
        response = Typhoeus.get("https://wri-01.cartodb.com/api/v2/sql?q=WITH%20loss%20as%20(SELECT%20sum(loss_gt_0)%20as%20sum_loss%2C%20(SELECT%20sum(loss_gt_0)%20FROM%20umd%20WHERE%20year%20%3D%202012)%20as%20loss_2012%20FROM%20umd)%2C%20gain%20as%20(SELECT%20sum(umd.gain)%20last_gain%20FROM%20(SELECT%20DISTINCT%20iso%2C%20gain%20FROM%20umd)%20umd)%2C%20forma%20as%20(SELECT%20count(cartodb_id)%20as%20gain%20FROM%20forma_api%20WHERE%20date%20%3E%3D%20(SELECT%20max(date)%20FROM%20forma_api))%2C%20circles%20as%20(SELECT%20unnest(array%5B%27sum_loss%27%2C%20%27loss_2012%27%2C%20%27last_gain%27%2C%20%27gain%27%5D)%20AS%20slug%2C%20unnest(array%5Bsum_loss%2C%20loss_2012%2C%20last_gain%2C%20gain%5D)%20AS%20num%20FROM%20loss%2C%20gain%2C%20forma)%0A%0ASELECT%20*%20FROM%20carrousel%20LEFT%20OUTER%20JOIN%20circles%20ON%20(circles.slug%20%3D%20carrousel.slug)%20WHERE%20published%20IS%20true%20ORDER%20BY%20pos%20ASC",
            headers: {"Accept" => "application/json"}
        )
        if response.success?
          Rails.cache.fetch 'circles', expires_in: 1.day do
            JSON.parse(response.body)['rows']
          end
        else
          nil
        end
      rescue Exception => e
        Rails.logger.error "Error retrieving circles in the Home: #{e}"
      end
    end

end

app/views/home/index.html.erb
<% content_for :js do %>
  <script>
    var circleSummary = <%= @circles.to_json.html_safe %>;
  </script>
  <script id='circle-template' type='text/x-underscore-template'>
    <div class='circle-icon {{ icon }}'><i></i></div>

      {{#count}}
      <div class='circle-inner'>
        <div class='circle-counter'>{{ count }}</div>
        <div class='circle-title'>{{ title }}</div>
        <div class='circle-background'></div>
        <div class='circle-explore'>Explore the map</div>
      </div>
      {{/count}}

      {{^count}}
      <div class='circle-inner fake_title'>
        <a href="{{ link }}" class='circle-counter'>{{ title }}</div>
      </div>
      {{/count}}
    </div>
  </script>
<% end %>

<% content_for :header do %>
  <h1 class="header-title"><%= @title.html_safe %></h1>

  <div class="mod-checkouts">
    <%= link_to (
      "Check out " + content_tag(:span, "GFW Commodities")).html_safe,
      "http://commodities.globalforestwatch.org/", class: "gfw_sticker for_business", :target => "_blank" %>
    <%= link_to (
      "Check out "+content_tag(:span, "GFW Fires")).html_safe,
      "http://fires.globalforestwatch.org/", class: "gfw_sticker fires", :target => "_blank" %>
    <%= link_to (
      content_tag(:span, "HELP IMPROVE GFW!")).html_safe,
      "#{about_path}/testers", class: "gfw_testers", :target => "_blank" %>
  </div>
<% end %>

<%# content_for :filters do %>
  <!-- <div id="filters">
    <div class="inner">
      <div class="filters hide">
        <ul class="filters-list"></ul>
      </div>

      <div id="layer">
        <a href="#" class="filter-title"></a>

        <div class="filter-scroll">
          <ul class="filter-links"></ul>
        </div>

        <div class="filter-icon"></div>
        <div class="filter-line"></div>
      </div>
    </div>
  </div> -->
<%# end %>

<section class="layout-home-slider" id="homeSlider">
  <a href="/map" class="btn-mask"></a>
  <%= render "shared/feedback" %>
</section>

<section class="layout-home-actions section section_dark">
  <div class="inner">
    <ul class="columns">
      <li class="column three community">
        <i></i>
        <h3><%= t(".actions.community.title") %></h3>
        <p><%= t(".actions.community.text") %></p>
        <a href="https://groups.google.com/d/forum/globalforestwatch" class="btn darker_glow community" target="_blank"><%= t(".actions.community.link") %></a>
      </li>

      <li class="column three analysis_tool">
        <i></i>
        <h3><%= t(".actions.analysis.title") %></h3>
        <p><%= t(".actions.analysis.text") %></p>
        <%= link_to t(".actions.analysis.link"), '/map?analyze=1', :class => "btn darker_glow map ajax analyzing" %>
      </li>

      <li class="column three submit_story">
        <i></i>
        <h3><%= t(".actions.submit_story.title") %></h3>
        <p><%= t(".actions.submit_story.text") %></p>
        <%= link_to t(".actions.submit_story.link"), new_story_path, :class => "btn darker_glow" %>
      </li>
    </ul>
  </div>
</section>

<section class="section home_stories">
  <div class="inner">
    <h2 class="section-title">Stories about forest change</h2>
    <p class="section-desc">Browse <a href="/stories">featured user stories</a> or <a class="map ajax all" href="/map/3/15.00/27.00/ALL/580">explore all in the map</a>.</p>
    <ul class="columns">
      <li class="spinner"></li>
    </ul>
  </div>
</section>

<%# render "shared/stories" %>
<%# render "shared/sources" %>
<!-- <div id="sources" class="sources notranslate">

</div> -->